'use strict'
Object.defineProperty(exports, '__esModule', { value: true })
exports.stringify = exports.parse = void 0
/** Parse an envfile string */
function parse(src) {
	// Try parse envfile string
	const result = {}
	const lines = src.toString().split('\n')
	for (const line of lines) {
		const match = line.match(/^([^=:#]+?)[=:](.*)/)
		if (match) {
			const key = match[1].trim()
			const value = match[2].trim()
			result[key] = value
		}
	}
	return result
}
exports.parse = parse
/** Turn an object into an envfile string */
function stringify(obj) {
	// Prepare
	let result = ''
	// Stringify
	for (const [key, value] of Object.entries(obj)) {
		if (key) {
			const line = `${key}=${String(value)}`
			result += line + '\n'
		}
	}
	// Return
	return result
}
exports.stringify = stringify
